{% block caution %}
# {{ caution }}
{% endblock %}

{% block import %}
import os
from setuptools import setup, find_packages
{% endblock %}

{% block data_files %}
data_files = {{ data_files }}
if data_files:
    try:
        if os.geteuid() != 0:
            data_files.clear()
    except Exception:
        pass
{% endblock %}

{% block packages %}
packages = find_packages(os.path.dirname(__file__) or '.', exclude=['tests*'])
{% endblock %}

{% block setup %}
setup(
    author='{{ author }}',
    author_email='{{ author_email }}',
    classifiers={{ classifiers }},       
    description='{{ description }}',
    data_files=data_files,
    download_url='https://github.com/{{ github_user }}/{{ name }}/tarball/{{ version }}',
    entry_points={{ entry_points }},
    license='{{ license }}',
    maintainer='{{ maintainer }}',
    maintainer_email='{{ maintainer_email }}',
    name='{{ pypi_name }}',
    include_package_data=True,
    install_requires={{ install_requires }}, 
    packages=packages,
    platforms={{ platforms }},
    url='https://github.com/{{ github_user }}/{{ name }}',
    long_description='''{{ long_description }}''',     
    tests_require={{ tests_require }},
    test_suite='{{ test_suite }}',
    version='{{ version }}')
{% endblock %}