import os
import jinja2
from render import render_file
from run import Module


class UpdateModule(Module):

    # Meta

    meta_default_task = 'update'

    # Tasks

    # TODO: ignore files like __pycache__/*?
    def update(self):
        root = 'meta'
        if os.path.isdir(root):
            for dirpath, _, filenames in os.walk(root):
                for filename in sorted(filenames):
                    source = os.path.join(dirpath, filename)
                    target = os.path.relpath(source, start=root)
                    self.render_file(filepath=source, target=target)

    # TODO: change to RenderTask after inheritance added
    def render_file(self, *args, **kwargs):
        return render_file(
            *args,
            context=self.meta_main_module,
            trim_blocks=True,
            lstrip_blocks=True,
            loader=jinja2.ChoiceLoader([
                jinja2.FileSystemLoader('.'),
                jinja2.PrefixLoader({
                    'packgram': jinja2.PackageLoader(
                        'packgram', 'templates')})]), **kwargs)
