import os
import shutil
import unittest
from functools import partial
from packgram.create import create


class create_Test(unittest.TestCase):

    # Actions

    def setUp(self):
        self.pcreate = partial(create, command='')

    def tearDown(self):
        shutil.rmtree(self.make_path('path'), ignore_errors=True)

    # Helpers

    def make_path(self, *args):
        return os.path.join(os.path.dirname(__file__), 'fixtures', *args)

    # Tests

    def test(self):
        self.pcreate(self.make_path('path'))
        self.assertIn('runfile.py', os.listdir(self.make_path('path')))

    def test_with_path_already_exists(self):
        self.pcreate(self.make_path('path'))
        self.assertRaises(RuntimeError, self.pcreate, self.make_path('path'))
