import os
import unittest
from packgram.project import ProjectModule


class ProjectModuleTest(unittest.TestCase):

    # Actions

    def setUp(self):
        MockModule = self.make_mock_module()
        self.module = MockModule(meta_module=None,
                                 meta_basedir=self.basedir)

    # Helpers

    def make_mock_module(self):
        class MockModule(ProjectModule):
            # Public
            name = 'packgram'
        return MockModule

    @property
    def basedir(self, *args):
        return os.path.join(os.path.dirname(__file__), '..', '..')

    # Tests

    def test_long_description(self):
        self.assertRegex(self.module.long_description,
                         '.*pip install packgram.*')
